-- CREAR TABLA CON CONSTRAINT 

DROP TABLE  PRODUCTO;

CREATE TABLE  PRODUCTO 
            ( ID INT NOT NULL,
            NOMBRE VARCHAR2(20) NOT NULL,
            FEC_REGISTRO TIMESTAMP NOT NULL,
            CONSTRAINT PRODUCTO_PK PRIMARY KEY(ID)
            );

-- HEAD
create or replace
PACKAGE PCK_PRODUCTOS IS
TYPE RESULTADOS IS REF CURSOR;
--TYPE LISTA IS VARRAY(150) OF VARCHAR2(255);

PROCEDURE SP_EJEMPLO (
        pID IN INT ,
        pNOMBRE IN VARCHAR2,
        pFEC_REGISTRO TIMESTAMP,
        pPRODUCTOS OUT   RESULTADOS,
        pCODIGO OUT VARCHAR2,
        pMENSAJE OUT VARCHAR2); 

      
END PCK_PRODUCTOS;

-- BODY

create or replace
PACKAGE BODY PCK_PRODUCTOS IS

PROCEDURE SP_EJEMPLO (
        pID IN INT ,
        pNOMBRE IN VARCHAR2,
        pFEC_REGISTRO TIMESTAMP,
        pPRODUCTOS OUT   RESULTADOS,
        pCODIGO OUT VARCHAR2,
        pMENSAJE OUT VARCHAR2) IS
      
  BEGIN
  -- INSERTAMOS
  INSERT INTO PRODUCTO (ID, NOMBRE, FEC_REGISTRO )
  VALUES (pID, pNOMBRE, pFEC_REGISTRO);
  -- LLENAMOS CURSO CON LA DATA DE LA TABLA
  OPEN pPRODUCTOS FOR
  	SELECT ID, NOMBRE, FEC_REGISTRO FROM PRODUCTO;
  -- LLENAMOS EL CODIGO DE ERROR
  pCODIGO := SQLCODE;
  
  Exception
  	when others then
        pCODIGO := SQLCODE;
  		pMENSAJE := SQLERRM;	
  	
  END;    


END PCK_PRODUCTOS;


